﻿using System;

using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Configuration;
using Microsoft.Extensions.DependencyInjection;
using Microsoft.Extensions.DependencyInjection.Extensions;

using Platform.Logging.ConsoleLogger;

namespace Platform.Logging
{
    public static class PlatformConsoleLoggerExtensions 
    {
        public static ILoggingBuilder AddPlatformConsoleLogger( this ILoggingBuilder builder, IConfigurationSection section )
        {
            try
            {
                var provider = new PlatformConsoleLoggerProvider(section);
                builder.AddProvider(provider);

                // builder.AddConfiguration();
                // builder.Services.TryAddEnumerable(ServiceDescriptor.Singleton<ILoggerProvider, ConsoleLoggerProvider>());
                // builder.Services.TryAddEnumerable(ServiceDescriptor.Singleton<IConfigureOptions<ConsoleLoggerOptions>, ConsoleLoggerOptionsSetup>());
                // builder.Services.TryAddEnumerable(ServiceDescriptor.Singleton<IOptionsChangeTokenSource<ConsoleLoggerOptions>, LoggerProviderOptionsChangeTokenSource<ConsoleLoggerOptions, ConsoleLoggerProvider>>());
            }
            catch (Exception ex)
            {
                SimpleFileLogger.WriteLine("Failed to add Platform Console Logger: {0}", ex.Message);
            }

            return builder;
        }
    }
}
